/* 

*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <getopt.h>

static void usage()
{
	printf(
		"usage: tscalib [option ...]\n"
		"\n"
		"  -s, --start=VALUE            Start Value (Default Value = 4000)\n"
		"  -e, --end=VALUE              End Value (Default Value = -20000)\n"
		"  -t, --step=VALUE             Step Calue (Default Value = 100)\n"
		"\n"
		"  -h, --help                   display this help\n"
		"\n"
		);
	exit(1);
};


int main(int argc, char *argv[])
{
	int ts[3];
	FILE *fp;
	int i;
	int j;
	int n=0;
	int y_std;
	int ts_data;
	int start_val=4000;
	int end_val=-20000;
	int step_val=100;

	static struct option option_names[] = {
		{"start", 1, 0, 's'},
		{"end", 1, 0, 'e'},
		{"step", 1, 0, 't'},
		{"help", 0, 0, 'h'},
		{0, 0, 0, 0}
	};

	int c;
	int opt_index=0;

	while((c = getopt_long(argc, argv, "s:e:t:h",option_names, &opt_index)) != EOF){
		switch(c){
		case 'h':
			usage();
			break;
		case 's':
			start_val=atoi(optarg);
			break;
		case 'e':
			end_val=atoi(optarg);
			break;
		case 't':
			step_val=atoi(optarg);
			break;
		case '?':
			break;
		}
	}
	
	if (start_val < end_val){
		int tmp;
		tmp = end_val;
		end_val = start_val;
		start_val = tmp;
	}

	printf("Start %d ,End %d, Step %d\n", start_val, end_val, step_val);
	printf("Calibration Start\n");
	for(ts_data = start_val; ts_data > end_val ; ts_data -= step_val){
		fp = fopen("/dev/ts","w");
		fprintf(fp,"%d\n",ts_data);
		fclose(fp);
		fp = fopen("/dev/ts","r");
		for(i=0 ; i < 4 ; i++){
			ts[i] = getc(fp);
			ts[i] += (getc(fp) << 8);	
		}
		y_std = ts[2];
		for(j=0 ; j <40 ; j++){
			for(i=0 ; i < 4 ; i++){
				ts[i] = getc(fp);
				ts[i] += (getc(fp) << 8);	
			}
			printf("\rX=%03d ;Y=%03d ;n=%05d ;ts_data=%05d   ",ts[1],ts[2],n,ts_data);
			fflush(NULL);

			if ( abs(y_std - ts[2]) >= 2)
				break;
			if (j == 39){
				printf("\rCalibration Number = %5d                 \n",ts_data);
			}
			n++;
		}
	}

  return 0;
}
